
CoCoALib - Bug #1542

gfan does not "deinitialize"

02 Dec 2020 20:49 - John Abbott

Status: In Progress Start date: 02 Dec 2020

Priority: Normal Due date:  

Assignee:  % Done: 30%

Category: Various Estimated time: 0.00 hour

Target version: CoCoALib-0.99880 Spent time: 1.25 hour

Description

I have been "playing" with MemPool, and found that gfanlib seems to allocate 7 GMP values which are never freed.

There is a function deinitializeCddlibIfRequired() defined in file gfanlib-zcone.cpp but its body is commented out.

Is this right?

Well, I suppose the good new is that the new version of MemPool did not crash horribly...

History

#1 - 03 Dec 2020 11:48 - John Abbott

Now I wonder whether I disabled the call to deinitialize myself.

The problem almost certainly arises only when GMPAllocator is used when initializing CoCoALib (and MemPool is active).

The risk is that some GMP values (used by CDDlib) may be allocated using MemPool but during final clean-up they could be handed to system

free/delete.

That will probably cause a crash... any volunteers to investigate?  :-/

#2 - 03 Dec 2020 20:30 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 30

I have uncommented the suspicious commented out call in GFAN, and everything seems to work fine now.

I hope Anna can confirm that that line was not commented out in her version of gfanlib.  Then maybe we can close this issue.

#3 - 05 Dec 2020 14:15 - John Abbott

I downloaded gfan (v. 0.6.2) from the official website.

The subtree layout is quite different from what I have!

Also the body of deinitializeCDDIfNeeded was indeed commented out!

I have written to Anders for clarification.

#4 - 22 Dec 2020 16:10 - John Abbott

A non-solution is to modify the documentation to say that GMPAllocator does not work well with GFan  (or else the user must modify GFan so that it

cleans up).

#5 - 08 Mar 2023 19:53 - John Abbott
- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880
